<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.plot.params &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.plot.params</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.plot.params</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Plot the values of some parameters</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Dict</span>

<span class="kn">import</span> <span class="nn">matplotlib</span> <span class="k">as</span> <span class="nn">mpl</span>
<span class="kn">from</span> <span class="nn">uncertainties</span> <span class="kn">import</span> <span class="n">ufloat</span><span class="p">,</span> <span class="n">unumpy</span> <span class="k">as</span> <span class="n">unp</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">.</span> <span class="kn">import</span> <span class="n">tools</span>
<span class="kn">from</span> <span class="nn">..handle.handle_str</span> <span class="kn">import</span> <span class="n">turn_into_latex_friendly</span>


<span class="k">def</span> <span class="nf">_plot_params_one_cat</span><span class="p">(</span>
    <span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">,</span>
    <span class="n">list_params</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span>
    <span class="n">list_param_ylocs</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span>
    <span class="n">marker</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="n">capsize</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mi">3</span><span class="p">,</span> <span class="n">capthick</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mi">1</span><span class="p">,</span>
    <span class="n">markersize</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mi">4</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Plot the values of the parameters in a two-dimensional plot.</span>

<span class="sd">    * y-axis: the different parameters</span>
<span class="sd">    * x-axis: value of the parameter</span>

<span class="sd">    Args:</span>
<span class="sd">        ax: where to plot</span>
<span class="sd">        list_params: List of parameter values (along the x-axis)</span>
<span class="sd">        list_param_ylocs: list of parameter positions along the y-axis</span>
<span class="sd">        marker, capsize, capthick, markersize: for style</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">list_params</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">list_params</span><span class="p">)</span>
    <span class="n">list_param_ylocs</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">asarray</span><span class="p">(</span><span class="n">list_param_ylocs</span><span class="p">)</span>

    <span class="n">ax</span><span class="o">.</span><span class="n">errorbar</span><span class="p">(</span>
        <span class="n">x</span><span class="o">=</span><span class="n">unp</span><span class="o">.</span><span class="n">nominal_values</span><span class="p">(</span><span class="n">list_params</span><span class="p">),</span>
        <span class="n">y</span><span class="o">=</span><span class="n">list_param_ylocs</span><span class="p">,</span>
        <span class="n">xerr</span><span class="o">=</span><span class="n">unp</span><span class="o">.</span><span class="n">std_devs</span><span class="p">(</span><span class="n">list_params</span><span class="p">),</span>
        <span class="n">linestyle</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span>
        <span class="n">marker</span><span class="o">=</span><span class="n">marker</span><span class="p">,</span> <span class="n">capsize</span><span class="o">=</span><span class="n">capsize</span><span class="p">,</span> <span class="n">capthick</span><span class="o">=</span><span class="n">capthick</span><span class="p">,</span>
        <span class="n">markersize</span><span class="o">=</span><span class="n">markersize</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">)</span>


<div class="viewcode-block" id="plot_params"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.params.plot_params">[docs]</a><span class="k">def</span> <span class="nf">plot_params</span><span class="p">(</span>
    <span class="n">dict_params_cats</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Union</span><span class="p">[</span><span class="nb">int</span><span class="p">,</span> <span class="nb">float</span><span class="p">,</span> <span class="n">ufloat</span><span class="p">]]],</span>
    <span class="n">dict_param_labels</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">xlabel</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s2">&quot;Value&quot;</span><span class="p">,</span> <span class="n">ylabel</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">dict_cat_offsets</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
    <span class="n">show_leg</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
    <span class="n">max_offset</span><span class="o">=</span><span class="mf">0.2</span><span class="p">,</span>
    <span class="n">ax</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
    <span class="n">dict_cat_kwargs</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="n">mpl</span><span class="o">.</span><span class="n">figure</span><span class="o">.</span><span class="n">Figure</span><span class="p">,</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot; Plot the value of some parameters for different categories,</span>
<span class="sd">    in a two-dimensional plot:</span>

<span class="sd">    * y-axis: the different parameters</span>
<span class="sd">    * x-axis: value of the parameter</span>

<span class="sd">    Args:</span>
<span class="sd">        dict_params_cats: Associates the name of a category with another</span>
<span class="sd">            dictionnary that gives the value each parameter</span>
<span class="sd">            (using ``ufloat`` to introduce errors)</span>
<span class="sd">        dict_param_labels: Associates a parameter name with its label</span>
<span class="sd">        xlabel: label of the x axis of the plot</span>
<span class="sd">        ylabel: label of the y axis of the plot</span>
<span class="sd">        dict_cat_offsets: associates a category with the offset to apply to it</span>
<span class="sd">            in the plot. If not provided, computed with an offset s.t.</span>
<span class="sd">            the offsets are scattered from ``- max_ffset`` to ``+ max_offset``</span>
<span class="sd">        show_leg: whether to show the legend</span>
<span class="sd">        max_offset: Maximal offset along the y-axis. Only used if</span>
<span class="sd">            ``dict_cat_offsets`` is not provided.</span>
<span class="sd">        ax (matplotlib.figure.Axes): Axis of the plot</span>
<span class="sd">        dict_cat_kwargs: associates a category with a set of plot parameters</span>
<span class="sd">            passed to :py:func:`ax.errorbar` (which may be different for each</span>
<span class="sd">            category)</span>
<span class="sd">        kwargs: passed to :py:func:`ax.errorbar`</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * fig:  Figure of the plot (only if ``ax`` is not specified)</span>
<span class="sd">        * ax: Axis of the plot (only if ``ax`` is not specified)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">list_cats</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dict_params_cats</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span>
    <span class="n">nb_cats</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_cats</span><span class="p">)</span>
    <span class="c1"># DEFAULT VALUES ======================================================</span>
    <span class="k">if</span> <span class="n">dict_cat_kwargs</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">dict_cat_kwargs</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">if</span> <span class="n">dict_param_labels</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">dict_param_labels</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">if</span> <span class="n">dict_cat_offsets</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">dict_cat_offsets</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">cat</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">list_cats</span><span class="p">):</span>
            <span class="n">dict_cat_offsets</span><span class="p">[</span><span class="n">cat</span><span class="p">]</span> <span class="o">=</span> <span class="p">(</span><span class="n">max_offset</span>
                                     <span class="o">-</span> <span class="n">i</span> <span class="o">*</span> <span class="mi">2</span> <span class="o">*</span> <span class="n">max_offset</span> <span class="o">/</span> <span class="p">(</span><span class="n">nb_cats</span> <span class="o">-</span> <span class="mi">1</span><span class="p">))</span>

    <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">tools</span><span class="o">.</span><span class="n">get_fig_ax</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">8</span><span class="p">,</span> <span class="mi">8</span><span class="p">))</span>

    <span class="c1">#: List of all parameter names</span>
    <span class="n">list_params</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">(</span>
        <span class="p">[</span><span class="nb">list</span><span class="p">(</span><span class="n">dict_params</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="k">for</span> <span class="n">dict_params</span> <span class="ow">in</span> <span class="n">dict_params_cats</span><span class="o">.</span><span class="n">values</span><span class="p">()]</span>
    <span class="p">))</span>

    <span class="c1"># Values along the y-axis ==============================================</span>
    <span class="n">list_ylocs</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">list_params</span><span class="p">))</span>
    <span class="n">dict_param_ylocs</span> <span class="o">=</span> <span class="p">{</span>
        <span class="n">param</span><span class="p">:</span> <span class="n">yloc</span>
        <span class="k">for</span> <span class="n">param</span><span class="p">,</span> <span class="n">yloc</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">list_params</span><span class="p">,</span> <span class="n">list_ylocs</span><span class="p">)</span>
    <span class="p">}</span>
    <span class="n">list_param_labels</span> <span class="o">=</span> <span class="p">[</span>
        <span class="n">dict_param_labels</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">param</span><span class="p">,</span> <span class="n">turn_into_latex_friendly</span><span class="p">(</span><span class="n">param</span><span class="p">))</span>
        <span class="k">for</span> <span class="n">param</span> <span class="ow">in</span> <span class="n">list_params</span>
    <span class="p">]</span>
    <span class="c1"># Ticks</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_yticks</span><span class="p">(</span><span class="n">list_ylocs</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_yticklabels</span><span class="p">(</span><span class="n">list_param_labels</span><span class="p">)</span>

    <span class="c1"># PLOT =================================================================</span>
    <span class="k">for</span> <span class="n">cat</span><span class="p">,</span> <span class="n">dict_params</span> <span class="ow">in</span> <span class="n">dict_params_cats</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="n">list_param_ylocs</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span>
            <span class="n">dict_param_ylocs</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">param_name</span> <span class="ow">in</span> <span class="n">dict_params</span>
        <span class="p">])</span>
        <span class="n">_plot_params_one_cat</span><span class="p">(</span>
            <span class="n">ax</span><span class="p">,</span>
            <span class="nb">list</span><span class="p">(</span><span class="n">dict_params</span><span class="o">.</span><span class="n">values</span><span class="p">()),</span>
            <span class="n">list_param_ylocs</span> <span class="o">+</span> <span class="n">dict_cat_offsets</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">cat</span><span class="p">,</span> <span class="mi">0</span><span class="p">),</span>
            <span class="o">**</span><span class="n">dict_cat_kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">cat</span><span class="p">,</span> <span class="p">{}),</span>
            <span class="o">**</span><span class="n">kwargs</span>
        <span class="p">)</span>
    <span class="c1"># x and y labels</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="n">xlabel</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="n">ylabel</span><span class="p">)</span>

    <span class="c1"># Legend, grid</span>
    <span class="n">tools</span><span class="o">.</span><span class="n">show_grid</span><span class="p">(</span><span class="n">ax</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">show_leg</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>

    <span class="k">if</span> <span class="n">fig</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>